require "db_attr/version"

module DbAttr
  def self.included(klass)
    klass.extend(ClassMethods)
  end

  def db_attr(attribute)
    self.class.db_attr(attribute)
  end

  module ClassMethods
    def db_attr(attribute)
      Attribute.new(arel_table[attribute])
    end
  end

  class Attribute < Arel::Attributes::Attribute
    def initialize(attribute)
      super(attribute.relation, attribute.name)
    end

    alias_method :"!=", :not_eq
    alias_method :==, :eq
    alias_method :in?, :in
    alias_method :>=, :gteq
    alias_method :>, :gt
    alias_method :<, :lt
    alias_method :<=, :lteq
  end
end

